//Very Tiny Worm
//version 1
//By Sparr
//(c) 2004 Clarence Risher
//sparr0@gmail.com
//Released under the GNU GPL, latest version available at http://www.gnu.org/licenses/gpl.txt

//this preserves the registers
#define REGISTERSAVE
//variable speed
#define SPEEDCHANGE
//score display
#define SHOWSCORE
//high score
#define HIGHSCORE


#define NO_CALC_DETECT
#include <tigcclib.h>
#undef __need_in_use_bit
#define __need_in_use_bit ((void)0)
#include "extgraph.h"

//max worm length
#define ARRAYLENGTH 6000

unsigned char (*wormpoints)[2];
register short wormhead asm("a3"), wormtail asm("a4");
short wormmaxlength;
register unsigned char wpx asm("d5"),wpy asm("d6"),wd asm("d7");
unsigned char fx,fy;
#ifdef HIGHSCORE
short highscore=0;
#endif

void XORPix(short x, short y) {
	EXT_XORPIX(LCD_MEM,x,y);
}

void XORFood() {
	XORPix(fx,fy);
	XORPix(fx+1,fy);
	XORPix(fx+1,fy+1);
	XORPix(fx,fy+1);
}

short collide() {
	return EXT_GETPIX(LCD_MEM,wpx,wpy);
}

// Main Function
void _main(void)
{
#ifdef REGISTERSAVE
	short a3backup=wormhead;
	short a2backup=wormtail;
	short d5backup=wpx;
	short d6backup=wpy;
	short d7backup=wd;
#endif
	if(!(wormpoints=malloc(2*ARRAYLENGTH*sizeof(unsigned char)))) return;
	randomize();
	short x,timer;
#ifdef SPEEDCHANGE
	short speed=300;
#endif
	start:
	wormhead=0;
	wormtail=0;
	wormmaxlength=32;
	wd=0;
	wpx=80;
	wpy=40;
	fx=80;
	fy=40;
	ClrScr();
	for(x=160;x--;) {
		XORPix(x,0);
		XORPix(x,89);
	}
	for(x=90;x--;) {
		XORPix(0,x);
		XORPix(159,x);
	}
	XORFood();
	do {
		while((unsigned char)(wpx-fx)<=1&&(unsigned char)(wpy-fy)<=1) {
			XORFood();
			wormmaxlength=wormmaxlength*4/3;
			wormmaxlength=wormmaxlength>=ARRAYLENGTH-1?ARRAYLENGTH-2:wormmaxlength;
			fx=rand()%157+1;
			fy=rand()%87+1;
			XORFood();
		}
#ifdef HIGHSCORE
		highscore=highscore>wormmaxlength?highscore:wormmaxlength;
#endif		
#if defined(HIGHSCORE)||defined(SHOWSCORE)
		for(x=4,timer=1;x--;timer*=10) {
#ifdef HIGHSCORE
			DrawChar(x*6+80,91,((highscore/timer)%10)+'0',A_REPLACE);
#endif
#ifdef SHOWSCORE
			DrawChar(x*6,91,((wormmaxlength/timer)%10)+'0',A_REPLACE);
#endif
		}
#endif
		if(collide()) break;
		XORPix(wpx,wpy);
		wormhead--;
		wormhead=(wormhead+ARRAYLENGTH)%ARRAYLENGTH;
		wormpoints[wormhead][0]=wpx;
		wormpoints[wormhead][1]=wpy;
		if((wormtail-wormhead+ARRAYLENGTH)%ARRAYLENGTH>wormmaxlength) {
			wormtail--;
			wormtail=(wormtail+ARRAYLENGTH)%ARRAYLENGTH;
			XORPix(wormpoints[wormtail][0],wormpoints[wormtail][1]);
		}
#ifdef SPEEDCHANGE
		timer=speed;
#else
		timer=300;
#endif
		for(;timer--;) {
			if(kbhit()) {
				timer=0;
				switch (ngetchx()) {
					case KEY_LEFT:
						wd=(wd+1)%4; break;
					case KEY_RIGHT:
						wd=(wd+3)%4; break;
#ifdef SPEEDCHANGE
					case '+':
						speed=speed*3/4; break;
					case '-':
						speed=speed*4/3; break;
#endif
					case KEY_ESC:
						goto quit;
				}
			}
		}
		wpx+=(!(wd&1))*(1-wd);
		wpy+=(wd&1)*(wd-2);
	}while(1);
	if(DlgMessage("Game Over!","Play Again?",BT_YES,BT_NO)==KEY_ENTER)
		goto start;
	quit:
	free(wormpoints);
#ifdef REGISTERSAVE
	wormhead=a3backup;
	wormtail=a2backup;
	wpx=d5backup;
	wpy=d6backup;
	wd=d7backup;
#endif
	return;
}
